import java.awt.event.*;
import java.awt.*;
import javax.swing.*;
import java.util.Random;
import java.util.concurrent.*;

public class GrafikGUI  implements ActionListener,  MouseMotionListener, Runnable {
    JButton but1;
    JLabel lab1;
    JGrafikPanel grafikbereich;
    JFrame frame;

    public void zeigeFenster() {
        setSchriftgroesse(14);

        frame = new JFrame();
        frame.setDefaultCloseOperation( JFrame.EXIT_ON_CLOSE );
        frame.setTitle("Ameisenhaufen");
        frame.setLayout(null); 

        grafikbereich = new JGrafikPanel();
        grafikbereich.setBounds(10,80,300,300);
        frame.add(grafikbereich);
        Ameise[] as = erzeugeAmeisenstaat();
        grafikbereich.setAmeisenstaat(as);
        grafikbereich.addMouseMotionListener(this);

        but1 = new JButton("hier passiert nichts");
        but1.setBounds(10,10,200,40);
        but1.addActionListener(this);
        frame.add( but1 );

        lab1 = new JLabel("Ameisenhaufen...");
        lab1.setBounds(10,50,450,30);
        frame.add(lab1);

        frame.pack();
        frame.setSize(500,430);
        frame.setResizable(false);
        frame.setVisible( true );

        // sorgt dafür, dass die run-Methode in dieser Klasse alle 50ms aufgerufen wird (nach 500ms Startverzögerung)
        ScheduledThreadPoolExecutor stpe = new ScheduledThreadPoolExecutor(3);
        stpe.scheduleAtFixedRate(this, 500, 50, TimeUnit.MILLISECONDS);

    }

    public void actionPerformed(ActionEvent e) {
        if(e.getSource() == but1) {
            // beim Button-Click passiert noch nichts
        }
        frame.repaint();
    }
    
    // Called in response to the user moving the mouse while holding a mouse button down. 
    // This event is fired by the component that fired the most recent mouse-pressed event, 
    // even if the cursor is no longer over that component.
    public void mouseDragged(MouseEvent event) {
    }
    
    // Called in response to the user moving the mouse with no mouse buttons pressed. 
    // This event is fired by the component that's currently under the cursor.    
    public void mouseMoved(MouseEvent event) {
        Point pos = event.getPoint();
        grafikbereich.setMousePosition(pos);
        System.out.println("moved: "+pos.x+" "+pos.y);
        
    }
    
    public void run() {
        
        if(grafikbereich != null) {
            grafikbereich.nextFrame();
        }
        frame.repaint();
    }
    
    public Ameise[] erzeugeAmeisenstaat() {
        Random r = new Random();
        Ameise[] as = new Ameise[250];
        for(int i=0; i<as.length; i++) {
            int px = r.nextInt(300);
            int py = r.nextInt(300);
            Color c = new Color(r.nextInt(256), r.nextInt(256), r.nextInt(256));
            as[i] = new Ameise(px,py,c);
        }
        return as;
    }
    

    void setSchriftgroesse(int s) {
        Font f = new Font("Arial", Font.BOLD, s);

        UIManager.put("Button.font",f);
        UIManager.put("ToggleButton.font",f);
        UIManager.put("RadioButton.font", f);
        UIManager.put("CheckBox.font", f);
        UIManager.put("ColorChooser.font", f);
        UIManager.put("ComboBox.font", f);
        UIManager.put("Label.font",f);
        UIManager.put("List.font", f);
        UIManager.put("MenuBar.font", f);
        UIManager.put("MenuItem.font", f);
        UIManager.put("RadioButtonMenuItem.font", f);
        UIManager.put("CheckBoxMenuItem.font", f);
        UIManager.put("Menu.font", f);
        UIManager.put("PopupMenu.font", f);
        UIManager.put("OptionPane.font", f);
        UIManager.put("Panel.font", f);
        UIManager.put("ProgressBar.font", f);
        UIManager.put("ScrollPane.font", f);
        UIManager.put("Viewport.font", f);
        UIManager.put("TabbedPane.font", f);
        UIManager.put("Table.font", f);
        UIManager.put("TableHeader.font", f);
        UIManager.put("TextField.font", f);
        UIManager.put("PasswordField.font", f);
        UIManager.put("TextArea.font", f);
        UIManager.put("TextPane.font", f);
        UIManager.put("EditorPane.font", f);
        UIManager.put("TitledBorder.font", f);
        UIManager.put("ToolBar.font", f);
        UIManager.put("ToolTip.font", f);
        UIManager.put("Tree.font", f);        
    }

}
